<template>
  <v-form @submit="submitForm">
    <v-row>
      <v-col cols="12" md="6">
        <form-group :validator="$v.username" name="username">
          <template slot-scope="{ attrs }">
            <v-text-field
              v-model="username"
              v-bind="attrs"
              @blur="$v.username.$touch()"
              label="username"
              outlined
            ></v-text-field>
          </template>
        </form-group>
      </v-col>
      <v-col cols="12" md="6">
        <form-group :validator="$v.password" name="password">
          <template slot-scope="{ attrs }">
            <v-text-field
              v-model="password"
              v-bind="attrs"
              @blur="$v.password.$touch()"
              label="Password"
              outlined
            ></v-text-field>
          </template>
        </form-group>
      </v-col>
      <v-col cols="12">
        <v-btn type="submit" variant="primary">Login</v-btn>
        <v-btn @click.prevent="socialLogin('facebook')" variant="primary"
          >Login With Facebook</v-btn
        >
        <v-btn @click.prevent="socialLogin('google')" variant="primary"
          >Login With Google</v-btn
        >
        <v-btn @click.prevent="socialLogin('linkedin')" variant="primary"
          >Login With LinkedIn</v-btn
        >
      </v-col>
    </v-row>
  </v-form>
</template>

<script>
import { required, email } from 'vuelidate/lib/validators'

export default {
  name: 'LoginPage',
  middleware: 'guest',

  data() {
    return {
      username: '',
      password: ''
    }
  },

  created() {
    console.log(this.$store.$auth)
  },
  methods: {
    async submitForm(evt) {
      evt.preventDefault()
      const credentials = {
        username: this.username,
        password: this.password
      }
      try {
        await this.$auth.loginWith('local', {
          data: credentials
        })
        this.$router.push('/')
      } catch (e) {
        this.$router.push('/login')
      }
    },

    // async loginWithFb() {
    //   try {
    //     await this.$auth.loginWith('facebook')
    //   } catch (e) {}
    // },

    // async loginWithGoogle() {
    //   try {
    //     await this.$auth.loginWith('google')
    //   } catch (e) {}
    // },

    async socialLogin(provider) {
      try {
        await this.$auth.loginWith(provider)
      } catch (e) {}
    }
  },

  validations() {
    return {
      username: {
        required,
        email
      },
      password: {
        required
      }
    }
  }
}
</script>
